#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n>>q;
    for (int tst = 0; tst < n; tst++) {
        int _;
        cin>>_;
    }
    for (int tst = 0; tst < q; tst++) {
        int tp, l, r;
        cin>>tp>>l>>r; l--; r--;
        if (l % 2 == 0) {
            l++;
        }
        if (r % 2 == 0) {
            r--;
        }
        cout << max(0, r - l + 1) << endl;
    }
}
